#include <Arduino.h>
#include <Wire.h>
#include <homekit/main.h>
#include <homekit/mqtt/mqtt.h>
#include <homekit/mqtt/module/relay.h>
#include <homekit/relay.h>

using namespace homekit;
using main::LoopConfig;
using mqtt::Mqtt;
using mqtt::MqttRelayModule;

MqttRelayModule* mqttRelayModule = nullptr;

static void onMqttCreated(Mqtt& mqtt);

LoopConfig loopConfig = {
        .onMqttCreated = onMqttCreated
};

void setup() {
    main::setup();
    relay::init();
}

void loop() {
    main::loop(&loopConfig);
}

static void onMqttCreated(Mqtt& mqtt) {
    if (mqttRelayModule == nullptr) {
        mqttRelayModule = new MqttRelayModule();
        mqtt.addModule(mqttRelayModule);
    }
}